package org.opengroup.osdu.notification.utils;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.Spy;
import org.mockito.junit.MockitoJUnitRunner;
import org.opengroup.osdu.core.common.model.http.DpsHeaders;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.io.IOException;

import static org.junit.Assert.assertNotNull;
import static org.mockito.ArgumentMatchers.any;
import static org.mockito.Mockito.doNothing;

@RunWith(MockitoJUnitRunner.class)
public class NotificationFilterTest {

    @InjectMocks
    private NotificationFilter notificationFilter;

    @Spy
    private DpsHeaders dpsHeaders;

    @Mock
    private FilterChain filterChain;

    @Mock
    private HttpServletRequest servletRequest;

    @Mock
    private HttpServletResponse servletResponse;



    @Before
    public void setup() throws ServletException, IOException {
        MockitoAnnotations.initMocks(NotificationFilterTest.this);
        doNothing().when(filterChain).doFilter(any(ServletRequest.class), any(ServletResponse.class));
    }

    @Test
    public void doFilterTest() throws ServletException, IOException {

        notificationFilter.doFilter(servletRequest, servletResponse, filterChain);
        assertNotNull(dpsHeaders.getHeaders().get("correlation-id"));

    }
}